diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
index 0256cad4a..f8f5a5f80 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
@@ -11,6 +11,8 @@ import com.google.gson.JsonSerializer;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.input.InputType;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
@@ -23,8 +25,8 @@ import java.util.ArrayList;
 import java.util.List;
 import java.util.Locale;
 
-public class CharKey extends Key{
-    private static int EXTRAS_HOLD_LENGTH = 300;
+public class CharKey extends Key {
+    private static final int EXTRAS_HOLD_LENGTH = 300;
     protected boolean renderChar = true;
     protected int lastRadial = 0;
     protected final CharGroup @NotNull [] groups;
@@ -38,7 +40,7 @@ public class CharKey extends Key{
     @Override
     public void render(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
         super.render(mc, keyboard, originX, originY, mouseX, mouseY);
-        if (!renderChar) return;
+        if (!this.renderChar) return;
         boolean hovered = isHovered(originX, originY, mouseX, mouseY);
         int texColor = hovered ? 0xFFFFA0 : 0xE0E0E0;
 
@@ -48,42 +50,42 @@ public class CharKey extends Key{
             CharGroup lastGroup = getGroup(keyboard.getShiftedGroup(-1));
 
             if (lastGroup != currentGroup && lastGroup != nextGroup) {
-                GL11.glPushMatrix();
-                GL11.glColor4f(0.75f, 0.75f, 0.75f, 1f);
-                GL11.glTranslatef(x + originX + 4, y + originY + 2, 0);
-                GL11.glScalef(0.75f, 0.75f, 1);
+                GLRenderer.pushFrame();
+                GLRenderer.setColor4f(0.75f, 0.75f, 0.75f, 1f);
+                GLRenderer.modelM4f().translate(this.x + originX + 4, this.y + originY + 2, 0);
+                GLRenderer.modelM4f().scale(0.75f, 0.75f, 1);
                 drawStringCenteredShadow(mc.font, String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? lastGroup.collections[0].upper : lastGroup.collections[0].lower), 0, 0, 0xE0E0E0);
-                GL11.glPopMatrix();
+                GLRenderer.popFrame();
             }
 
             if (nextGroup != currentGroup) {
-                GL11.glPushMatrix();
-                GL11.glColor4f(0.75f, 0.75f, 0.75f, 1f);
-                GL11.glTranslatef(x + width + originX - 4, y + originY + 2, 0);
-                GL11.glScalef(0.75f, 0.75f, 1);
+                GLRenderer.pushFrame();
+                GLRenderer.setColor4f(0.75f, 0.75f, 0.75f, 1f);
+                GLRenderer.modelM4f().translate(this.x + this.width + originX - 4, this.y + originY + 2, 0);
+                GLRenderer.modelM4f().scale(0.75f, 0.75f, 1);
                 drawStringCenteredShadow(mc.font, String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? nextGroup.collections[0].upper : nextGroup.collections[0].lower), 0, 0, 0xE0E0E0);
-                GL11.glPopMatrix();
+                GLRenderer.popFrame();
             }
         }
 //        if (isHovered) {
 //            drawStringCentered(mc.font, String.valueOf(getHoldTime()), x + width/2 + originX, y + mc.font.fontHeight/2 + 4 + originY - 10, texColor);
 //        }
         if (getHoldTime() > EXTRAS_HOLD_LENGTH) {
-            double animProgress = MathHelper.clamp((getHoldTime() - EXTRAS_HOLD_LENGTH)/100d, 0, 1);
-            GL11.glPushMatrix();
-            GL11.glEnable(GL11.GL_BLEND);
+            double animProgress = MathHelper.clamp((getHoldTime() - EXTRAS_HOLD_LENGTH) / 100d, 0, 1);
+            GLRenderer.pushFrame();
+            GLRenderer.enableState(State.BLEND);
             GL11.glEnable(GL11.GL_DEPTH_TEST);
-            GL11.glTranslatef(0, 0, 10);
+            GLRenderer.modelM4f().translate(0, 0, 10);
 
             final int size = (int) (64 * animProgress);
             drawTexturedIcon(
-                x + (width - size)/2 + originX,
-                y + (height - size)/2  + originY + 2,
+                this.x + (this.width - size) / 2 + originX,
+                this.y + (this.height - size) / 2 + originY + 2,
                 size,
                 size,
                 TextureRegistry.getTexture("minecraft:gui/screen/keyboard/radial_background"));
 
-            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.getFont().fontHeight()/2 + 4 + originY, texColor);
+            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), this.x + this.width / 2 + originX, this.y + mc.font.getFont().fontHeight() / 2 + 4 + originY, texColor);
 
             final double dx;
             final double dy;
@@ -91,8 +93,8 @@ public class CharKey extends Key{
                 dx = mc.controllerInput.joyLeft.getX() * 20;
                 dy = mc.controllerInput.joyLeft.getY() * 20;
             } else {
-                dx = mouseX - (x + width/2d + originX);
-                dy = mouseY - (y + height/2d + originY);
+                dx = mouseX - (this.x + this.width / 2d + originX);
+                dy = mouseY - (this.y + this.height / 2d + originY);
             }
 
             int rIndex = getRadialIndex(mc, keyboard, dx, dy);
@@ -101,8 +103,8 @@ public class CharKey extends Key{
             for (int i = 0; i < currentGroup.collections.length; i++) {
                 CharCollection collection = currentGroup.collections[i];
 
-                int charX = MathHelper.floor(x + originX + width/2d + Math.cos(r * i - Math.PI/2) * 20 * animProgress);
-                int charY = MathHelper.floor(y + originY + height/2d + Math.sin(r * i - Math.PI/2) * 20 * animProgress) - 3;
+                int charX = MathHelper.floor(this.x + originX + this.width / 2d + Math.cos(r * i - Math.PI / 2) * 20 * animProgress);
+                int charY = MathHelper.floor(this.y + originY + this.height / 2d + Math.sin(r * i - Math.PI / 2) * 20 * animProgress) - 3;
 
                 drawStringCenteredShadow(
                     mc.font,
@@ -111,33 +113,33 @@ public class CharKey extends Key{
                     charY,
                     i == rIndex ? 0xFFFFA0 : 0xE0E0E0);
             }
-            GL11.glDisable(GL11.GL_BLEND);
-            GL11.glPopMatrix();
+            GLRenderer.disableState(State.BLEND);
+            GLRenderer.popFrame();
         } else {
-            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.getFont().fontHeight()/2 + 4 + originY, texColor);
+            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), this.x + this.width / 2 + originX, this.y + mc.font.getFont().fontHeight() / 2 + 4 + originY, texColor);
         }
-        GL11.glColor4f(1f, 1f, 1f, 1f);
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
     }
 
     protected int getRadialIndex(Minecraft mc, ScreenKeyboard keyboard, double dx, double dy) {
         if (getHoldTime() < EXTRAS_HOLD_LENGTH) {
-            lastRadial = 0;
+            this.lastRadial = 0;
             return 0;
         }
 
         final int deadzone = 7;
         if (Math.hypot(dx, dy) < deadzone) {
-            return lastRadial;
+            return this.lastRadial;
         }
 
         CharGroup currentGroup = getGroup(keyboard.getGroup());
         double r = (Math.PI * 2) / currentGroup.collections.length;
 
-        double mouseR = Math.atan2(dy, dx) + Math.PI/2 + r/2;
+        double mouseR = Math.atan2(dy, dx) + Math.PI / 2 + r / 2;
         if (mouseR < 0) mouseR += Math.PI * 2;
 
         int radial = MathHelper.floor(mouseR / r) % currentGroup.collections.length;
-        lastRadial = radial;
+        this.lastRadial = radial;
         return radial;
     }
 
@@ -161,8 +163,8 @@ public class CharKey extends Key{
             dx = mc.controllerInput.joyLeft.getX() * 20;
             dy = mc.controllerInput.joyLeft.getY() * 20;
         } else {
-            dx = mouseX - (x + width/2d + originX);
-            dy = mouseY - (y + height/2d + originY);
+            dx = mouseX - (this.x + this.width / 2d + originX);
+            dy = mouseY - (this.y + this.height / 2d + originY);
         }
 
         int rI = getRadialIndex(mc, keyboard, dx, dy);
@@ -170,7 +172,7 @@ public class CharKey extends Key{
     }
 
     protected CharGroup getGroup(int group) {
-        return group < groups.length ? groups[group] : groups[0];
+        return group < this.groups.length ? this.groups[group] : this.groups[0];
     }
 
     @Override
@@ -180,7 +182,7 @@ public class CharKey extends Key{
 
     @Override
     public int highestGroup() {
-        return groups.length - 1;
+        return this.groups.length - 1;
     }
 
     protected static class CharGroup {
@@ -194,6 +196,7 @@ public class CharKey extends Key{
     protected static class CharCollection {
         public char lower;
         public char upper;
+
         public CharCollection(char lower, char upper) {
             this.lower = lower;
             this.upper = upper;
@@ -264,19 +267,20 @@ public class CharKey extends Key{
             object.addProperty("y", src.y);
             if (src.width != DEFAULT_WIDTH) object.addProperty("width", src.width);
             if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
-            if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
+            if (src.controllerButton != null)
+                object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
             if (src.renderChar != DEFAULT_RENDER_CHAR) object.addProperty("renderChar", src.renderChar);
 
-            boolean ku = !src.keyUp.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP);
-            boolean kd = !src.keyDown.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
-            boolean kuh = !src.keyUpHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
-            boolean kdh = !src.keyDownHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
+            boolean ku = !src.keyUp.namespaceId.toString().equals(DEFAULT_TEXTURE_UP);
+            boolean kd = !src.keyDown.namespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
+            boolean kuh = !src.keyUpHovered.namespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
+            boolean kdh = !src.keyDownHovered.namespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
             if (ku || kd || kuh || kdh) {
                 JsonObject textureObject = new JsonObject();
-                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
-                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
-                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
-                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                if (ku) textureObject.addProperty("up", src.keyUp.namespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.namespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.namespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.namespaceId.toString());
                 object.add("textures", textureObject);
             }
 
@@ -285,8 +289,8 @@ public class CharKey extends Key{
                 JsonArray collections = new JsonArray(group.collections.length);
                 for (CharCollection collection : group.collections) {
                     JsonObject o = new JsonObject();
-                    o.addProperty("lower", (int)collection.lower);
-                    o.addProperty("upper", (int)collection.upper);
+                    o.addProperty("lower", (int) collection.lower);
+                    o.addProperty("upper", (int) collection.upper);
                     collections.add(o);
                 }
                 groups.add(collections);
@@ -347,17 +351,17 @@ public class CharKey extends Key{
 
         public CharKeyBuilder addGroup(char c) {
             CharCollection collection = new CharCollection(c, Character.toUpperCase(c));
-            groups.add(new CharGroup(new CharCollection[]{collection}));
+            this.groups.add(new CharGroup(new CharCollection[]{collection}));
             return this;
         }
 
         public CharKeyBuilder addGroup(char lower, char upper) {
             CharCollection collection = new CharCollection(lower, upper);
-            groups.add(new CharGroup(new CharCollection[]{collection}));
+            this.groups.add(new CharGroup(new CharCollection[]{collection}));
             return this;
         }
 
-        public CharKeyBuilder addGroup(char[] ... group) {
+        public CharKeyBuilder addGroup(char[]... group) {
             CharCollection[] collections = new CharCollection[group.length];
             for (int i = 0; i < group.length; i++) {
                 char[] arr = group[i];
@@ -367,19 +371,19 @@ public class CharKey extends Key{
                     collections[i] = new CharCollection(arr[0], Character.toUpperCase(arr[0]));
                 }
             }
-            groups.add(new CharGroup(collections));
+            this.groups.add(new CharGroup(collections));
             return this;
         }
 
         protected CharKeyBuilder addGroup(CharGroup group) {
-            groups.add(group);
+            this.groups.add(group);
             return this;
         }
 
         public CharKey build() {
-            CharGroup[] compiledGroups = groups.toArray(new CharGroup[0]);
-            CharKey key = new CharKey(x, y, width, height, renderChar, compiledGroups);
-            key.setControllerButton(controllerButton).setTextures(texUp, texDown, texUpHovered, texDownHovered);
+            CharGroup[] compiledGroups = this.groups.toArray(new CharGroup[0]);
+            CharKey key = new CharKey(this.x, this.y, this.width, this.height, this.renderChar, compiledGroups);
+            key.setControllerButton(this.controllerButton).setTextures(this.texUp, this.texDown, this.texUpHovered, this.texDownHovered);
             return key;
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CursorKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CursorKey.java
index e889ac411..feaca62eb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CursorKey.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CursorKey.java
@@ -86,10 +86,10 @@ public class CursorKey extends Key{
             boolean kdh = true;
             if (ku || kd || kuh || kdh) {
                 JsonObject textureObject = new JsonObject();
-                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
-                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
-                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
-                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                if (ku) textureObject.addProperty("up", src.keyUp.namespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.namespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.namespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.namespaceId.toString());
                 object.add("textures", textureObject);
             }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/EnterKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/EnterKey.java
index db15ae8e6..bab04b012 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/EnterKey.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/EnterKey.java
@@ -77,16 +77,16 @@ public class EnterKey extends Key{
             if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
             if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
 
-            boolean ku = !src.keyUp.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP);
-            boolean kd = !src.keyDown.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
-            boolean kuh = !src.keyUpHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
-            boolean kdh = !src.keyDownHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
+            boolean ku = !src.keyUp.namespaceId.toString().equals(DEFAULT_TEXTURE_UP);
+            boolean kd = !src.keyDown.namespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
+            boolean kuh = !src.keyUpHovered.namespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
+            boolean kdh = !src.keyDownHovered.namespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
             if (ku || kd || kuh || kdh) {
                 JsonObject textureObject = new JsonObject();
-                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
-                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
-                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
-                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                if (ku) textureObject.addProperty("up", src.keyUp.namespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.namespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.namespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.namespaceId.toString());
                 object.add("textures", textureObject);
             }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/GroupKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/GroupKey.java
index 982f43015..7c88466bb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/GroupKey.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/GroupKey.java
@@ -126,10 +126,10 @@ public class GroupKey extends Key{
             boolean kdh = true;
             if (ku || kd || kuh || kdh) {
                 JsonObject textureObject = new JsonObject();
-                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
-                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
-                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
-                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                if (ku) textureObject.addProperty("up", src.keyUp.namespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.namespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.namespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.namespaceId.toString());
                 object.add("textures", textureObject);
             }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/Key.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/Key.java
index 671b6cca5..94942e0d9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/Key.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/Key.java
@@ -14,6 +14,8 @@ import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.input.controller.IButton;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.sound.SoundCategory;
@@ -51,39 +53,40 @@ public abstract class Key extends Gui implements GuiElement {
     }
 
     public void onOpen(Minecraft mc, ScreenKeyboard keyboard) {
-        isDown = false;
-        isHovered = false;
+        this.isDown = false;
+        this.isHovered = false;
     }
+
     public void render(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
         boolean hovered = isHovered(originX, originY, mouseX, mouseY);
-        if (!isHovered && hovered) {
+        if (!this.isHovered && hovered) {
             onFocus(mc, keyboard, originX, originY, mouseX, mouseY);
         }
-        isHovered = hovered;
+        this.isHovered = hovered;
 
         boolean down = isDown(mc, keyboard);
         if (down) {
             if (hovered) {
-                drawGuiIcon(x + originX, y + originY, width, height, keyDownHovered);
+                drawGuiIcon(this.x + originX, this.y + originY, this.width, this.height, this.keyDownHovered);
             } else {
-                drawGuiIcon(x + originX, y + originY, width, height, keyDown);
+                drawGuiIcon(this.x + originX, this.y + originY, this.width, this.height, this.keyDown);
             }
         } else {
             if (hovered) {
-                drawGuiIcon(x + originX, y + originY, width, height, keyUpHovered);
+                drawGuiIcon(this.x + originX, this.y + originY, this.width, this.height, this.keyUpHovered);
             } else {
-                drawGuiIcon(x + originX, y + originY, width, height, keyUp);
+                drawGuiIcon(this.x + originX, this.y + originY, this.width, this.height, this.keyUp);
             }
         }
-        if (mc.inputType == InputType.CONTROLLER && controllerButton != null) {
-            GL11.glPushMatrix();
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glTranslatef(x + originX + width - 8, y + originY + 1, 0);
-            GL11.glColor4f(1, 1, 1, 0.5f);
-            GL11.glScalef(0.5f, 0.5f, 1);
-            keyboard.glyphRenderer.drawGlyph(mc.controllerInput, controllerButton.glyph, 0, 0);
-            GL11.glDisable(GL11.GL_BLEND);
-            GL11.glPopMatrix();
+        if (mc.inputType == InputType.CONTROLLER && this.controllerButton != null) {
+            GLRenderer.pushFrame();
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.modelM4f().translate(this.x + originX + this.width - 8, this.y + originY + 1, 0);
+            GLRenderer.setColor4f(1, 1, 1, 0.5f);
+            GLRenderer.modelM4f().scale(0.5f, 0.5f, 1);
+            keyboard.glyphRenderer.drawGlyph(mc.controllerInput, this.controllerButton.glyph, 0, 0);
+            GLRenderer.disableState(State.BLEND);
+            GLRenderer.popFrame();
         }
     }
 
@@ -94,8 +97,8 @@ public abstract class Key extends Gui implements GuiElement {
     public void onClick(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY, int mouseButton) {
         if (mouseButton == 0 && isHovered(originX, originY, mouseX, mouseY)) {
             pressAction(mc, keyboard, originX, originY, mouseX, mouseY);
-            holdStart = System.currentTimeMillis();
-            isDown = true;
+            this.holdStart = System.currentTimeMillis();
+            this.isDown = true;
         }
     }
 
@@ -115,23 +118,23 @@ public abstract class Key extends Gui implements GuiElement {
     }
 
     public void onRelease(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY, int mouseButton) {
-        if (isDown && mouseButton == 0) {
+        if (this.isDown && mouseButton == 0) {
             releaseAction(mc, keyboard, originX, originY, mouseX, mouseY);
-            isDown = false;
+            this.isDown = false;
         }
     }
 
     public void onButtonUse(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY) {
-        if (mc.inputType == InputType.CONTROLLER && mc.controllerInput != null && controllerButton != null) {
-            IButton button = controllerButton.getButton(mc.controllerInput);
+        if (mc.inputType == InputType.CONTROLLER && mc.controllerInput != null && this.controllerButton != null) {
+            IButton button = this.controllerButton.getButton(mc.controllerInput);
             if (button.pressedThisFrame()) {
                 pressAction(mc, keyboard, originX, originY, (int) mc.controllerInput.cursorX, (int) mc.controllerInput.cursorY);
-                holdStart = System.currentTimeMillis();
-                isDown = true;
+                this.holdStart = System.currentTimeMillis();
+                this.isDown = true;
             }
             if (button.releasedThisFrame()) {
                 releaseAction(mc, keyboard, originX, originY, (int) mc.controllerInput.cursorX, (int) mc.controllerInput.cursorY);
-                isDown = false;
+                this.isDown = false;
             }
         }
     }
@@ -150,7 +153,7 @@ public abstract class Key extends Gui implements GuiElement {
     }
 
     public long getHoldTime() {
-        return isDown ? System.currentTimeMillis() - holdStart : 0;
+        return this.isDown ? System.currentTimeMillis() - this.holdStart : 0;
     }
 
     @Override
@@ -175,38 +178,38 @@ public abstract class Key extends Gui implements GuiElement {
 
     @Override
     public int getX() {
-        return x;
+        return this.x;
     }
 
     @Override
     public int getY() {
-        return y;
+        return this.y;
     }
 
     @Override
     public int getWidth() {
-        return width;
+        return this.width;
     }
 
     @Override
     public int getHeight() {
-        return height;
+        return this.height;
     }
 
     public boolean isHovered(int originX, int originY, int mx, int my) {
         mx -= originX;
         my -= originY;
         return
-            x <= mx && mx < x + width &&
-            y <= my && my < y + height;
+            this.x <= mx && mx < this.x + this.width &&
+                this.y <= my && my < this.y + this.height;
     }
 
     public boolean isDown(Minecraft mc, ScreenKeyboard keyboard) {
-        return isDown || isButtonPressed(mc, keyboard);
+        return this.isDown || isButtonPressed(mc, keyboard);
     }
 
     public boolean isButtonPressed(Minecraft mc, ScreenKeyboard keyboard) {
-        return mc.inputType == InputType.CONTROLLER && controllerButton != null && mc.controllerInput != null && controllerButton.getButton(mc.controllerInput).isPressed();
+        return mc.inputType == InputType.CONTROLLER && this.controllerButton != null && mc.controllerInput != null && this.controllerButton.getButton(mc.controllerInput).isPressed();
     }
 
     public int highestGroup() {
@@ -216,6 +219,7 @@ public abstract class Key extends Gui implements GuiElement {
     public static class Serializer implements JsonSerializer<Key>, JsonDeserializer<Key> {
         public static final Map<String, Class<? extends Key>> ID_TO_KEY_CLASS = new HashMap<>();
         public static final Map<Class<? extends Key>, String> KEY_CLASS_TO_ID = new HashMap<>();
+
         static {
             registerKeyClass("key_char", CharKey.class);
             registerKeyClass("key_back", BackspaceKey.class);
@@ -254,21 +258,21 @@ public abstract class Key extends Gui implements GuiElement {
         BUTTON_X(ControllerGlyphElement.Glyph.BUTTON_X, c -> c.buttonX),
         BUTTON_Y(ControllerGlyphElement.Glyph.BUTTON_Y, c -> c.buttonY),
 
-        BUTTON_DPAD_UP(ControllerGlyphElement.Glyph.D_PAD_UP,c -> c.digitalPad.up),
-        BUTTON_DPAD_LEFT(ControllerGlyphElement.Glyph.D_PAD_LEFT,c -> c.digitalPad.left),
-        BUTTON_DPAD_DOWN(ControllerGlyphElement.Glyph.D_PAD_DOWN,c -> c.digitalPad.down),
-        BUTTON_DPAD_RIGHT(ControllerGlyphElement.Glyph.D_PAD_RIGHT,c -> c.digitalPad.right),
+        BUTTON_DPAD_UP(ControllerGlyphElement.Glyph.D_PAD_UP, c -> c.digitalPad.up),
+        BUTTON_DPAD_LEFT(ControllerGlyphElement.Glyph.D_PAD_LEFT, c -> c.digitalPad.left),
+        BUTTON_DPAD_DOWN(ControllerGlyphElement.Glyph.D_PAD_DOWN, c -> c.digitalPad.down),
+        BUTTON_DPAD_RIGHT(ControllerGlyphElement.Glyph.D_PAD_RIGHT, c -> c.digitalPad.right),
 
-        BUTTON_SHOULDER_LEFT(ControllerGlyphElement.Glyph.SHOULDER_LEFT,c -> c.buttonLeftShoulder),
-        BUTTON_SHOULDER_RIGHT(ControllerGlyphElement.Glyph.SHOULDER_RIGHT,c -> c.buttonRightShoulder),
+        BUTTON_SHOULDER_LEFT(ControllerGlyphElement.Glyph.SHOULDER_LEFT, c -> c.buttonLeftShoulder),
+        BUTTON_SHOULDER_RIGHT(ControllerGlyphElement.Glyph.SHOULDER_RIGHT, c -> c.buttonRightShoulder),
 
-        BUTTON_STICK_LEFT(ControllerGlyphElement.Glyph.STICK_LEFT_PRESS,c -> c.joyLeft.button),
-        BUTTON_STICK_RIGHT(ControllerGlyphElement.Glyph.STICK_RIGHT_PRESS,c -> c.joyRight.button),
+        BUTTON_STICK_LEFT(ControllerGlyphElement.Glyph.STICK_LEFT_PRESS, c -> c.joyLeft.button),
+        BUTTON_STICK_RIGHT(ControllerGlyphElement.Glyph.STICK_RIGHT_PRESS, c -> c.joyRight.button),
 
-        BUTTON_TRIGGER_LEFT(ControllerGlyphElement.Glyph.TRIGGER_LEFT,c -> c.buttonLeftTrigger),
-        BUTTON_TRIGGER_RIGHT(ControllerGlyphElement.Glyph.TRIGGER_RIGHT,c -> c.buttonRightTrigger),
+        BUTTON_TRIGGER_LEFT(ControllerGlyphElement.Glyph.TRIGGER_LEFT, c -> c.buttonLeftTrigger),
+        BUTTON_TRIGGER_RIGHT(ControllerGlyphElement.Glyph.TRIGGER_RIGHT, c -> c.buttonRightTrigger),
 
-        BUTTON_START(ControllerGlyphElement.Glyph.BUTTON_START,c -> c.buttonStart),
+        BUTTON_START(ControllerGlyphElement.Glyph.BUTTON_START, c -> c.buttonStart),
         BUTTON_BACK(ControllerGlyphElement.Glyph.BUTTON_BACK, c -> c.buttonBack);
 
         public final @NotNull ControllerGlyphElement.Glyph glyph;
@@ -280,7 +284,7 @@ public abstract class Key extends Gui implements GuiElement {
         }
 
         public @NotNull IButton getButton(ControllerInput controller) {
-            return buttonGetter.apply(controller);
+            return this.buttonGetter.apply(controller);
         }
 
         private interface ButtonGetter {
